Name:     kyodialog
Version:  9.3
Release:  alt1

Summary:  Kyocera printing package
License: GPLv2+
Group:  System/Configuration

Packager: Anton Shevtsov <shevtsov.anton@gmail.com>

Requires: cups libcups python3 python3-module-Reportlab libkrb5 libqt4-core qt5-qtbase-gui
Requires: python3-module-PyPDF3 

BuildRequires: rpm-build-python3 rpm-build-xdg

BuildArch: x86_64

AutoReq: No

Source: %name-%version.tgz

%description 
Kyocera printing package.

%description -l ru_RU.UTF-8
Kyocera printing package

%prep

%setup -n %name-%version

%install

#no need more, use python3-module-PyPDF3
#mkdir -p %buildroot/%_datadir/kyocera9.3/Python/PyPDF3-1.0.1/{Sample_Code,Resources,PyPDF3,Scripts,Tests}

mkdir -p %buildroot/%_datadir/kyocera9.3/ppd9.3
mkdir -p %buildroot/%_desktopdir
mkdir -p %buildroot/%_defaultdocdir/%name
mkdir -p %buildroot/%_bindir
mkdir -p %buildroot/%_libexecdir/cups/filter
mkdir -p %buildroot/etc/dbus-1/system.d
mkdir -p %buildroot/%_xdgconfigdir/autostart

cp -r usr/* %buildroot/usr/
cp -r etc/* %buildroot/etc/

# alt5 (add custom kyocera ppd for older models)
# FS-1040,FS-1020MFP,FS-1025MFP,FS-1120MFP,FS-1125MFP,FS-1060DN
mkdir -p %buildroot/%_datadir/cups/model/Kyocera/

cp alt5/Kyocera_FS-1040GDI.ppd %buildroot/usr/share/cups/model/Kyocera/Kyocera_FS-1040GDI.ppd
cp alt5/Kyocera_FS-1020MFPGDI.ppd %buildroot/usr/share/cups/model/Kyocera/Kyocera_FS-1020MFPGDI.ppd
cp alt5/Kyocera_FS-1025MFPGDI.ppd %buildroot/usr/share/cups/model/Kyocera/Kyocera_FS-1025MFPGDI.ppd
cp alt5/Kyocera_FS-1120MFPGDI.ppd %buildroot/usr/share/cups/model/Kyocera/Kyocera_FS-1120MFPGDI.ppd
cp alt5/Kyocera_FS-1125MFPGDI.ppd %buildroot/usr/share/cups/model/Kyocera/Kyocera_FS-1125MFPGDI.ppd
cp alt5/Kyocera_FS-1060DNGDI.ppd %buildroot/usr/share/cups/model/Kyocera/Kyocera_FS-1060DNGDI.ppd 
cp alt5/rastertokpsl %buildroot/%_libexecdir/cups/filter/rastertokpsl



#%build

%pre
#Variable Initialization
###############################################################################

PHASE2_PPDS=/usr/share/cups/model/Kyocera/
PHASE3_PPDS=/usr/share/ppd/kyocera/
PHASE4_PPDS=/usr/share/kyocera/ppd4/
PHASE5_PPDS=/usr/share/kyocera/ppd5/
PHASE6_PPDS=/usr/share/kyocera/ppd6/
PHASE7_PPDS=/usr/share/kyocera/ppd7/
PHASE8_PPDS=/usr/share/kyocera/ppd8/
LINUX9_PPDS=/usr/share/kyocera/ppd9/
LINUX9_1_PPDS='/usr/share/kyocera/ppd9.1/'

INS_VER="9.3"

#Handle Upgrades
###############################################################################

handle_phase2(){
    if [ -d $PHASE2_PPDS ]; then
        rm -rvf $PHASE2_PPDS
    fi
}

handle_phase3(){
    if [ -d $PHASE3_PPDS ]; then
        rm -rvf $PHASE3_PPDS
    fi
}

handle_phase4(){
    if [ -d $PHASE4_PPDS ]; then
        if [ "$(ls -A $PHASE4_PPDS)" ]; then
            INS_VER=4
            print_warning
            exit 1
        fi
    fi
}

handle_phase5(){
    if [ -d $PHASE5_PPDS ]; then
        if [ "$(ls -A $PHASE5_PPDS)" ]; then
            INS_VER=5
            print_warning
            exit 1
        fi
    fi
}

handle_phase6(){
    if [ -d $PHASE6_PPDS ]; then
        if [ "$(ls -A $PHASE6_PPDS)" ]; then
            INS_VER=6
            print_warning
            exit 1
        fi
    fi
}

handle_phase7(){
    if [ -d $PHASE7_PPDS ]; then
        if [ "$(ls -A $PHASE7_PPDS)" ]; then
            INS_VER=7
            print_warning
            exit 1
        fi
    fi
}

handle_phase8(){
    if [ -d $PHASE8_PPDS ]; then
        if [ "$(ls -A $PHASE8_PPDS)" ]; then
            INS_VER=8
            print_warning
            exit 1
        fi
    fi
}

handle_linux9(){
    if [ -d $LINUX9_PPDS ]; then
        if [ "$(ls -A $LINUX9_PPDS)" ]; then
            INS_VER=9
            print_warning
            exit 1
        fi
    fi
}

handle_linux9_1(){
    if [ -d $LINUX9_1_PPDS ]; then
        if [ "$(ls -A $LINUX9_1_PPDS)" ]; then
            INS_VER=9
            print_warning
            exit 1
        fi
    fi
}

# add RU
print_warning(){
    echo ""
    lang=$LANGUAGE
    if [ -z "$lang" ]; then
        lang="$LANG"
    fi
    case "$lang" in
	*ru*) echo "Вы должны удалить версию $INS_VER перед установкой версии 9.3." ;;
        *en*) echo "You must uninstall Version $INS_VER before installing Version 9.3." ;;
        *fr*) echo "Vous devez désinstaller Version $INS_VER avant d'installer Version 9.3." ;;
        *de*) echo "Sie müssen Ausführung $INS_VER deinstallieren, bevor Ausführung 9.3 installiert wird." ;;
        *it*) echo "Occorre disinstallare Versione $INS_VER prima di installare Versione 9.3." ;;
        *es*) echo "Debe desinstalar la Versión $INS_VER antes de instalar la Versión 9.3." ;;
        *pt*) echo "Você precisa desinstalar a Versão $INS_VER antes de instalar a Versão 9.3." ;;
        *) echo "You must uninstall Version $INS_VER before installing Version 9.3." ;;
    esac
    echo ""
}

#Execution
###############################################################################

handle_phase2
handle_phase3
handle_phase4
handle_phase5
handle_phase6
handle_phase7
handle_phase8
handle_linux9
handle_linux9_1

%post

#!/bin/sh

#Constants
###############################################################################
ALTERNATE_PPD_DIRECTORY=/usr/share/cups/model/kyocera
PRIMARY_PPD_DIRECTORY=/usr/share/ppd/kyocera/
INSTALLED_PPD_DIRECTORY="/usr/share/kyocera/ppd9.3"
TMP_INSTALL="/usr/share/kyocera9.3/"

PYTHON_DIRECTORY=/usr/share/kyocera/Python/

KYOCERA_CONFIG=/usr/share/kyocera

#Phase 5 post install
###############################################################################

install_from_tmp(){
    rm -rf $KYOCERA_CONFIG
    ln -s $TMP_INSTALL $KYOCERA_CONFIG 
}

install_ppds(){
    mkdir -p $PRIMARY_PPD_DIRECTORY
    cp -r $INSTALLED_PPD_DIRECTORY/* $PRIMARY_PPD_DIRECTORY
}

fix_file_permissions(){
    chmod 777 /usr/share/kyocera
    chmod 755 "/usr/bin/kyodialog9.3"
    chmod 755 /usr/bin/kyoPPDWrite_H
}

link_alternate_ppds(){
    if [ ! -h $ALTERNATE_PPD_DIRECTORY ]; then
        ln -s $PRIMARY_PPD_DIRECTORY $ALTERNATE_PPD_DIRECTORY
    fi
}

#Not necessary
#skip for ALT. See Requires

install_pypdf(){ 
    if [ -f /usr/bin/python3 ]; then
        if python3 -c 'import PyPDF3' 2> /dev/null ; then
            #echo "PyPDF found"
            true
        else 
            python_version=$(python3 -c 'import sys; print(str(sys.version_info[0])+"."+str(sys.version_info[1]))')
            mkdir -p /usr/local/lib/python"$python_version"/site-packages/
            cd $PYTHON_DIRECTORY/PyPDF3-1.0.1/ || exit
            python3 setup.py install
        fi
    else
        if python -c 'import PyPDF3' 2> /dev/null ; then
            #echo "PyPDF found"
            true
        else 
            python_version=$(python -c 'import sys; print(str(sys.version_info[0])+"."+str(sys.version_info[1]))')
            mkdir -p /usr/local/lib/python"$python_version"/site-packages/
            cd $PYTHON_DIRECTORY/PyPDF3-1.0.1/ || exit
            python setup.py install
        fi
    fi
}

fix_mime_file(){
    mime_line="application/postscript      application/vnd.cups-pdf 66  pstopdf"
    cups_conf='/etc/cups/local.convs'
    if [ -e "/usr/lib/cups/filter/pstopdf" ]; then
        if [ -e $cups_conf ]; then
            grep -q -F "$mime_line" $cups_conf || echo "$mime_line" >> $cups_conf
        else 
            echo "$mime_line" > $cups_conf
        fi
    fi
}

start_knmd(){
    user=$(logname) 2>/dev/null
    if [ -z "$user" ]; then
        /usr/bin/knmd
    else
        su - "$user" -c 'DISPLAY=:0 /usr/bin/knmd'
    fi
}

# add RU
print_warning(){
    echo ""
    lang="$LANGUAGE"
    if [ -z "$lang" ]; then
        lang="$LANG"
    fi
    case "$lang" in
        *ru*) echo "Возможно вы должны перезапустить dbus для полной функциональности." ;;
        *en*) echo "You may need to restart dbus for full functionality." ;;
        *fr*) echo "Vous devrez éventuellement redémarrer D-Bus pour obtenir toutes les fonctionnalités." ;;
        *de*) echo "Für den vollen Funktionsumfang müssen Sie D-Bus neu starten." ;;
        *it*) echo "Per la completa funzionalità, potrebbe essere necessario il riavvio di D-Bus." ;;
        *es*) echo "Debe reiniciar D-Bus para una funcionalidad completa." ;;
        *pt*) echo "Você pode precisar reiniciar o D-Bus para uma completa funcionalidade." ;;
        *) echo "You may need to restart dbus for full functionality." ;;
    esac
    echo ""
}

# removed Reportlab script. Not necessary for ALT, see Requires
# <removed_code_been_here>

#Execution
###############################################################################

install_from_tmp
install_ppds
fix_file_permissions
link_alternate_ppds
#install_pypdf
fix_mime_file
start_knmd
print_warning

%postun
KYOCERA_CONFIG="/usr/share/kyocera"

uninstall_printers(){
    files=$(grep -l "kyofilter_H\|kyofilter_ras_H\|kyofilter_pdf_H\|kyofilter_kpsl_H" /etc/cups/ppd/*.ppd 2>/dev/null)
    if [ -n "$files" ]; then
        for file in ${files}; do
            if matches "$file" .ppd; then
                basefile=$(basename "$file" .ppd)
                lpadmin -x "$basefile"
            fi
        done
    fi
}

get_user_printer_list(){
    # $1 is user
    if [ -d $KYOCERA_CONFIG/"$1"  ]; then 
        ls $KYOCERA_CONFIG/"$1"
    fi
}

uninstall_kyocera_config_files(){
    # $1 is user
    # $2 is printer list
    rm -rf "${KYOCERA_CONFIG:?}/$1/"
}

# fix domain user home path
uninstall_lpoptions_config_files(){
    # $1 is user
    # $2 is printer list

    #lp_options="/home/$1/.cups/lpoptions"
    lp_options="$(getent passwd $1| awk -F ':' '{print $6}')/.cups/lpoptions"

    #echo "Editing lpoptions config file"
    if [ -n "$2" ]; then 
        for printer in ${printers}; do
            #echo "sed $base_printer $lp_options"
            sed -i "s/\(Dest\|Default\) $base_printer.*//" "$lp_options"
        done
    fi
}

uninstall_config_files(){
    #For each user, uninstall the config files in
    #/usr/share/kyocera/<username> and ~/.cups/lpoptions
    if [ -d $KYOCERA_CONFIG ]; then
        users=$(ls $KYOCERA_CONFIG | grep -v 'ppd4\|ppd5\|ppd6\|ppd7\|ppd8\|ppd9\|ppd9.1\|ppd9.2\|ppd9.3\|appicon\|Python')
        if [ -n "$users" ]; then
            for user in ${users}; do
                is_appicon=$(matches "$user" appicon.png)
                is_python=$(matches "$user" Python)
                if [ ! "$is_appicon" ] && [ ! "$is_python" ] ;then
                    printers=$(get_user_printer_list "$user")
                    uninstall_kyocera_config_files "$user" "$printers"
                    uninstall_lpoptions_config_files "$user" "$printers"
                fi
            done
        fi
    fi
}

remove_directories(){
    rm -rf /usr/share/cups/model/kyocera
    if [ -d /usr/share/ppd/kyocera ]; then
        rm -rf "/usr/share/ppd/kyocera"
    fi
    if [ -d /usr/share/kyocera/Python ]; then
        rm -rf "/usr/share/kyocera/Python"
    fi
    if [ -d "/usr/share/kyocera/ppd9.3" ]; then
        rm -rf "/usr/share/kyocera/ppd9.3"
    fi
    if [ -L $KYOCERA_CONFIG ]; then
        rm -rf $KYOCERA_CONFIG
    fi
}

kill_knmd(){
    pkill 'knmd'
}

matches(){
    input="$1"
    pattern="$2"
    echo "$input" | grep -q "$pattern"
}


uninstall_printers
uninstall_config_files
remove_directories
kill_knmd


%files
#%doc copyright
%config %_sysconfdir/dbus-1/system.d/com.kyocera.knm.conf
%_xdgconfigdir/autostart/*
%_datadir/kyocera9.3/*
%_desktopdir/*
%_bindir/*
%_libexecdir/cups/filter/*
%_datadir/cups/model/Kyocera/

%changelog
* Tue Aug 29 2023 Anton Shevtsov <shevtsov.anton@gmail.com> 9.3-alt1
- Fix paths, requires for ALT
- Add RU language

* Tue Oct 27 2022 Anton Shevtsov <shevtsov.anton@gmail.com> 9.2-alt2
- Bug fixes

* Fri Oct 21 2022 Anton Shevtsov <shevtsov.anton@gmail.com> 9.2-alt1
- Reassembly from the official CentOS package
- Add FS-1040,FS-1020MFP,FS-1025MFP,FS-1120MFP,FS-1125MFP,FS-1060DN
